// Scripted by Miller.
// Shard:  UO Resurgence <http://www.uoresurgence.com>
// This script is designed to compliment the CustomWeaponAbilities
// as scripted by Gargouille, with enhancements by Lord_Greywolf
// <http://www.runuo.com/forums/custom-script-releases/93672-runuo-2-0-rc1-customizable-weaponabilities.html>
// Customize this script as you wish, but please leave this header
using System;
using Server;
using Server.Gumps;
using Server.Items;
using Server.Network;
using Server.Mobiles;
using Server.Multis;
using Server.Commands;

namespace Server.Gumps
{
    public class ThirdAttacksGump : Gump
    {
        Mobile caller;
        ThirdAbilityDeed deed;

        public static void Initialize() 
        {
            CommandSystem.Register("ThirdAttacksGump", AccessLevel.Administrator, new CommandEventHandler(_OnCommand));
        }

        [Usage("ThirdAttacksGump")]
        [Description("Opens the Third Attacks Selector Gump")]
        public static void _OnCommand(CommandEventArgs e)
        {
            Mobile caller = e.Mobile as Mobile;
        
            if (caller.HasGump(typeof(ThirdAttacksGump)))
                caller.CloseGump(typeof(ThirdAttacksGump));
            caller.SendGump(new ThirdAttacksGump(caller, null));
        }

        public ThirdAttacksGump(Mobile from, ThirdAbilityDeed deedtouse) : this()
        {
            caller = from;
            deed = deedtouse;
        }

        public ThirdAttacksGump() : base(270, 210)
        {
            this.Closable=false;
			this.Disposable=false;
			this.Dragable=true;
			this.Resizable=false;

			AddPage(0);
			AddBackground(0, 0, 483, 334, 9200);
			AddImage(32, 10, 20992);
			AddImage(32, 64, 20993);
			AddImage(32, 118, 20994);
			AddImage(32, 172, 20995);
			AddImage(32, 226, 20996);
			AddImage(32, 280, 20997);
			AddImage(130, 10, 20998);
			AddImage(130, 64, 20999);
			AddImage(130, 118, 21000);
			AddImage(130, 172, 21001);
			AddImage(130, 226, 21002);
			AddImage(130, 280, 21003);
			AddImage(228, 10, 21004);
			AddImage(228, 64, 21005);
			AddImage(228, 118, 21006);
			AddImage(228, 172, 21007);
			AddImage(228, 226, 21008);
			AddImage(228, 280, 21009);
			AddImage(326, 10, 21010);
			AddImage(326, 64, 21011);
			AddImage(326, 118, 21012);
			AddImage(326, 172, 21013);
			AddImage(326, 226, 21014);
			AddImage(326, 280, 21015);
			AddImage(424, 10, 21016);
			AddImage(424, 64, 21017);
			AddImage(424, 118, 21018);
			AddImage(424, 172, 21019);
			AddImage(424, 226, 21020);
            AddButton(10, 25, 1209, 1210, (int)Buttons.ArmorIgnore, GumpButtonType.Reply, 0);
            AddButton(10, 79, 1209, 1210, (int)Buttons.BleedAttack, GumpButtonType.Reply, 0);
            AddButton(10, 133, 1209, 1210, (int)Buttons.ConcussionBlow, GumpButtonType.Reply, 0);
            AddButton(10, 187, 1209, 1210, (int)Buttons.CrushingBlow, GumpButtonType.Reply, 0);
            AddButton(10, 241, 1209, 1210, (int)Buttons.Disarm, GumpButtonType.Reply, 0);
			AddButton(10, 295, 1209, 1210, (int)Buttons.Dismount, GumpButtonType.Reply, 0);
			AddButton(108, 25, 1209, 1210, (int)Buttons.DoubleStrike, GumpButtonType.Reply, 0);
			AddButton(108, 79, 1209, 1210, (int)Buttons.InfectiousStrike, GumpButtonType.Reply, 0);
			AddButton(108, 133, 1209, 1210, (int)Buttons.MortalStrike, GumpButtonType.Reply, 0);
			AddButton(108, 187, 1209, 1210, (int)Buttons.MovingShot, GumpButtonType.Reply, 0);
			AddButton(108, 241, 1209, 1210, (int)Buttons.ParalyzingBlow, GumpButtonType.Reply, 0);
			AddButton(108, 295, 1209, 1210, (int)Buttons.ShadowStrike, GumpButtonType.Reply, 0);
			AddButton(206, 25, 1209, 1210, (int)Buttons.WhirlwindAttack, GumpButtonType.Reply, 0);
			AddButton(206, 79, 1209, 1210, (int)Buttons.RidingSwipe, GumpButtonType.Reply, 0);
			AddButton(206, 133, 1209, 1210, (int)Buttons.FrenziedWhirlwind, GumpButtonType.Reply, 0);
			AddButton(206, 187, 1209, 1210, (int)Buttons.Block, GumpButtonType.Reply, 0);
			AddButton(206, 241, 1209, 1210, (int)Buttons.DefenseMastery, GumpButtonType.Reply, 0);
			AddButton(206, 295, 1209, 1210, (int)Buttons.NerveStrike, GumpButtonType.Reply, 0);
			AddButton(304, 25, 1209, 1210, (int)Buttons.TalonStrike, GumpButtonType.Reply, 0);
			AddButton(304, 79, 1209, 1210, (int)Buttons.Feint, GumpButtonType.Reply, 0);
			AddButton(304, 133, 1209, 1210, (int)Buttons.DualWield, GumpButtonType.Reply, 0);
			AddButton(304, 187, 1209, 1210, (int)Buttons.DoubleShot, GumpButtonType.Reply, 0);
			AddButton(304, 241, 1209, 1210, (int)Buttons.ArmorPierce, GumpButtonType.Reply, 0);
			AddButton(304, 295, 1209, 1210, (int)Buttons.Bladeweave, GumpButtonType.Reply, 0);
			AddButton(402, 25, 1209, 1210, (int)Buttons.ForceArrow, GumpButtonType.Reply, 0);
			AddButton(402, 79, 1209, 1210, (int)Buttons.LightningArrow, GumpButtonType.Reply, 0);
			AddButton(402, 133, 1209, 1210, (int)Buttons.PsychicAttack, GumpButtonType.Reply, 0);
			AddButton(402, 187, 1209, 1210, (int)Buttons.SerpentArrow, GumpButtonType.Reply, 0);
			AddButton(402, 241, 1209, 1210, (int)Buttons.ForceOfNature, GumpButtonType.Reply, 0);
            AddButton(404, 290, 242, 241, (int)Buttons.Cancel, GumpButtonType.Reply, 0);     
        }

        		public enum Buttons
		{
			ArmorIgnore,
			BleedAttack,
			ConcussionBlow,
			CrushingBlow,
			Disarm,
			Dismount,
			Cancel,
			DoubleStrike,
			InfectiousStrike,
			MortalStrike,
			MovingShot,
			ParalyzingBlow,
			ShadowStrike,
			WhirlwindAttack,
			RidingSwipe,
			FrenziedWhirlwind,
			Block,
			DefenseMastery,
			NerveStrike,
			TalonStrike,
			Feint,
			DualWield,
			DoubleShot,
			ArmorPierce,
			Bladeweave,
			ForceArrow,
			LightningArrow,
			PsychicAttack,
			SerpentArrow,
			ForceOfNature,
		}

        public static void ThirdAbilityEffect(Mobile from)
        {
            BaseWeapon weapon = from.Weapon as BaseWeapon;
            
            int soundID;
            
            switch (weapon.Skill)
            {
                case SkillName.Macing: soundID = 0x232; break;
                case SkillName.Archery: soundID = 0x145; break;
                default: soundID = 0x56; break;
            }

            from.PlaySound(0x1E9);
            from.PlaySound(soundID);
            from.FixedParticles(0x3779, 1, 30, 9964, 3, 3, EffectLayer.Waist);
        }

        public override void OnResponse(NetState sender, RelayInfo info)
        {
            Mobile from = sender.Mobile;
            BaseWeapon weapon = from.Weapon as BaseWeapon;
            
            if ((deed == null || deed.Deleted) && from.AccessLevel==AccessLevel.Player)
            {
                from.SendMessage("You cannot learn further from this tattered scroll");
                return;
            }

            switch(info.ButtonID)
            {
                case (int)Buttons.ArmorIgnore:
				{
                    if (weapon is BaseRanged)
                    {
                        from.SendMessage("You cannot learn this with a ranged weapon");
                    }
                    else
                    {
                        weapon.ThirdAbilityName = WeaponAbilityName.ArmorIgnore;
                        ThirdAbilityEffect(from);
                        if (deed != null && !deed.Deleted) deed.Delete();
                    }
					break;
				}
				case (int)Buttons.BleedAttack:
				{
                    weapon.ThirdAbilityName = WeaponAbilityName.BleedAttack;
                    ThirdAbilityEffect(from);
                    if(deed!= null && !deed.Deleted) deed.Delete();
                    break;
				}
				case (int)Buttons.ConcussionBlow:
				{
                    weapon.ThirdAbilityName = WeaponAbilityName.ConcussionBlow;
                    ThirdAbilityEffect(from);
                    if(deed!= null && !deed.Deleted) deed.Delete();
                    break;
				}
				case (int)Buttons.CrushingBlow:
				{
                    if (weapon is BaseBashing)
                    {
                        weapon.ThirdAbilityName = WeaponAbilityName.CrushingBlow;
                        ThirdAbilityEffect(from);
                        if (deed != null && !deed.Deleted) deed.Delete();
                    }
                    else
                    {
                        from.SendMessage("You cannot learn this without a bashing weapon");
                    }
                    break;
				}
				case (int)Buttons.Disarm:
				{
                    weapon.ThirdAbilityName = WeaponAbilityName.Disarm;
                    ThirdAbilityEffect(from);
                    if(deed!= null && !deed.Deleted) deed.Delete();
                    break;
				}
				case (int)Buttons.Dismount:
				{
                    weapon.ThirdAbilityName = WeaponAbilityName.Dismount;
                    ThirdAbilityEffect(from);
                    if(deed!= null && !deed.Deleted) deed.Delete();
                    break;
				}
				case (int)Buttons.DoubleStrike:
				{
                    weapon.ThirdAbilityName = WeaponAbilityName.DoubleStrike;
                    ThirdAbilityEffect(from);
                    if(deed!= null && !deed.Deleted) deed.Delete();
                    break;
				}
				case (int)Buttons.InfectiousStrike:
				{
                    if (weapon is BaseBashing || weapon is BaseRanged)
                    {
                        from.SendMessage("You cannot learn this with a bashing or ranged weapon");
                    }
                    else
                    {
                        weapon.ThirdAbilityName = WeaponAbilityName.InfectiousStrike;
                        ThirdAbilityEffect(from);
                        if (deed != null && !deed.Deleted) deed.Delete();
                    }
                    break;
				}
				case (int)Buttons.MortalStrike:
				{
                    weapon.ThirdAbilityName = WeaponAbilityName.MortalStrike;
                    ThirdAbilityEffect(from);
                    if(deed!= null && !deed.Deleted) deed.Delete();
                    break;
				}
				case (int)Buttons.MovingShot:
				{
                    if (weapon is BaseRanged)
                    {
                        weapon.ThirdAbilityName = WeaponAbilityName.MovingShot;
                        ThirdAbilityEffect(from);
                        if (deed != null && !deed.Deleted) deed.Delete();
                    }
                    else
                    {
                        from.SendMessage("You cannot learn this without a ranged weapon");
                    }
                    break;
				}
				case (int)Buttons.ParalyzingBlow:
				{
                    weapon.ThirdAbilityName = WeaponAbilityName.ParalyzingBlow;
                    ThirdAbilityEffect(from);
                    if(deed!= null && !deed.Deleted) deed.Delete();
                    break;
				}
				case (int)Buttons.ShadowStrike:
				{
                    weapon.ThirdAbilityName = WeaponAbilityName.ShadowStrike;
                    ThirdAbilityEffect(from);
                    if(deed!= null && !deed.Deleted) deed.Delete();
					break;
				}
				case (int)Buttons.WhirlwindAttack:
				{
                    weapon.ThirdAbilityName = WeaponAbilityName.WhirlwindAttack;
                    ThirdAbilityEffect(from);
                    if(deed!= null && !deed.Deleted) deed.Delete();
					break;
				}
				case (int)Buttons.RidingSwipe:
				{
                    weapon.ThirdAbilityName = WeaponAbilityName.RidingSwipe;
                    ThirdAbilityEffect(from);
                    if(deed!= null && !deed.Deleted) deed.Delete();
					break;
				}
				case (int)Buttons.FrenziedWhirlwind:
				{
                    weapon.ThirdAbilityName = WeaponAbilityName.FrenziedWhirlwind;
                    ThirdAbilityEffect(from);
                    if(deed!= null && !deed.Deleted) deed.Delete();
					break;
				}
				case (int)Buttons.Block:
				{
                    weapon.ThirdAbilityName = WeaponAbilityName.Block;
                    ThirdAbilityEffect(from);
                    if(deed!= null && !deed.Deleted) deed.Delete();
					break;
				}
				case (int)Buttons.DefenseMastery:
				{
                    weapon.ThirdAbilityName = WeaponAbilityName.DefenseMastery;
                    ThirdAbilityEffect(from);
                    if(deed!= null && !deed.Deleted) deed.Delete();
					break;
				}
				case (int)Buttons.NerveStrike:
				{
                    weapon.ThirdAbilityName = WeaponAbilityName.NerveStrike;
                    ThirdAbilityEffect(from);
                    if(deed!= null && !deed.Deleted) deed.Delete();
					break;
				}
				case (int)Buttons.TalonStrike:
				{
                    weapon.ThirdAbilityName = WeaponAbilityName.TalonStrike;
                    ThirdAbilityEffect(from);
                    if(deed!= null && !deed.Deleted) deed.Delete();
					break;
				}
				case (int)Buttons.Feint:
				{
                    weapon.ThirdAbilityName = WeaponAbilityName.Feint;
                    ThirdAbilityEffect(from);
                    if(deed!= null && !deed.Deleted) deed.Delete();
					break;
				}
				case (int)Buttons.DualWield:
				{
                    weapon.ThirdAbilityName = WeaponAbilityName.DualWield;
                    ThirdAbilityEffect(from);
                    if(deed!= null && !deed.Deleted) deed.Delete();
					break;
				}
				case (int)Buttons.DoubleShot:
				{
                    if (weapon is BaseRanged)
                    {
                        weapon.ThirdAbilityName = WeaponAbilityName.DoubleShot;
                        ThirdAbilityEffect(from);
                        if(deed!= null && !deed.Deleted) deed.Delete();
                    }
                    else
                    {
                        from.SendMessage("You cannot learn this without a ranged weapon");
                    }
					break;
				}
				case (int)Buttons.ArmorPierce:
				{
                    if (weapon is BaseRanged)
                    {
                        weapon.ThirdAbilityName = WeaponAbilityName.ArmorPierce;
                        ThirdAbilityEffect(from);
                        if (deed != null && !deed.Deleted) deed.Delete();
                    }
                    else
                    {
                        from.SendMessage("You cannot learn this without a ranged weapon");
                    }
					break;
				}
				case (int)Buttons.Bladeweave:
				{
                    weapon.ThirdAbilityName = WeaponAbilityName.Bladeweave;
                    ThirdAbilityEffect(from);
                    if(deed!= null && !deed.Deleted) deed.Delete();
					break;
				}
				case (int)Buttons.ForceArrow:
				{
                    if (weapon is BaseRanged)
                    {
                        weapon.ThirdAbilityName = WeaponAbilityName.ForceArrow;
                        ThirdAbilityEffect(from);
                        if(deed!= null && !deed.Deleted) deed.Delete();
                    }
                    else
                    {
                        from.SendMessage("You cannot learn this without a ranged weapon");
                    }
					break;
				}
				case (int)Buttons.LightningArrow:
				{
                    if (weapon is BaseRanged)
                    {
                        weapon.ThirdAbilityName = WeaponAbilityName.LightningArrow;
                        ThirdAbilityEffect(from);
                        if (deed != null && !deed.Deleted) deed.Delete();
                    }
                    else
                    {
                        from.SendMessage("You cannot learn this without a ranged weapon");
                    }
					break;
				}
				case (int)Buttons.PsychicAttack:
				{
                    weapon.ThirdAbilityName = WeaponAbilityName.PsychicAttack;
                    ThirdAbilityEffect(from);
                    if(deed!= null && !deed.Deleted) deed.Delete();
					break;
				}
				case (int)Buttons.SerpentArrow:
				{
                    if (weapon is BaseRanged)
                    {
                        weapon.ThirdAbilityName = WeaponAbilityName.SerpentArrow;
                        ThirdAbilityEffect(from);
                        if (deed != null && !deed.Deleted) deed.Delete();
                    }
                    else
                    {
                        from.SendMessage("You cannot learn this without a ranged weapon");
                    }
					break;
				}
				case (int)Buttons.ForceOfNature:
				{
                    weapon.ThirdAbilityName = WeaponAbilityName.ForceOfNature;
                    ThirdAbilityEffect(from);
                    if(deed!= null && !deed.Deleted) deed.Delete();
					break;
				}
                case (int)Buttons.Cancel:
                {
                    break;
                }

            }
        }
    }
}